<template>
  <form class="edit-project" @submit.prevent="submit">
    <div class="form-field">
      <label for="previosPassword">Предыдущий пароль</label>
      <prime-input-text
        id="previosPassword"
        v-model="previosPassword"
        :disabled="isLoading"
        autofocus
        type="password"
      />
    </div>

    <div class="form-field">
      <label for="newPassword">Новый пароль</label>
      <prime-input-text
        id="newPassword"
        v-model="newPassword"
        type="password"
        :disabled="isLoading"
      />
    </div>

    <prime-button label="Сохранить" type="submit" />
  </form>
</template>

<script lang="ts">
import PrimeButton from 'primevue/button/Button.vue';
import PrimeInputText from 'primevue/inputtext/InputText.vue';
import { defineComponent } from 'vue';
import { changePassword } from '@/api/handler/user';

export default defineComponent({
  name: 'change-password',
  components: {
    PrimeButton,
    PrimeInputText,
  },
  emits: ['close'],
  data() {
    return {
      previosPassword: '',
      newPassword: '',

      isLoading: false,
    };
  },
  methods: {
    async submit() {
      this.isLoading = true;
      const promise = changePassword({
        previosPassword: this.previosPassword,
        newPassword: this.newPassword,
      });

      const res = await promise;
      if (res.__state === 'success') {
        this.$emit('close');
      } else {
        this.$toast.add({ severity: 'error', detail: 'Что-то пошло не так', life: 3000 });
      }
      this.isLoading = false;
    },
  },
});
</script>

<style lang="scss" scoped>
.edit-project {
  width: 25rem;
}

.p-field * {
  display: block;
}
</style>
